local r = reaper 
local huge = math.huge    

r.Undo_BeginBlock()
r.PreventUIRefresh(1)

local st_tm, en_tm = r.GetSet_ArrangeView2(0,0,0,0);

-------------------------------Check Razor Edits-----------------------------

function RazorEditSelectionExists()
    for i=0, r.CountTracks(0)-1 do
        local retval, x = r.GetSetMediaTrackInfo_String(r.GetTrack(0,i), "P_RAZOREDITS", "string", false)
        if x ~= "" then return true end
    end--for
return false
end--
re_exist = RazorEditSelectionExists() 
 
---------------------------------------RE_Splits----------------------------------------

if re_exist then

left, right = huge, -huge
for t = 0, r.CountTracks(0)-1 do
    local track = r.GetTrack(0, t)
    local razorOK, razorStr = r.GetSetMediaTrackInfo_String(track, "P_RAZOREDITS", "", false)
    if razorOK and #razorStr ~= 0 then
        for razorLeft, razorRight, envGuid in razorStr:gmatch([[([%d%.]+) ([%d%.]+) "([^"]*)"]]) do
--      r.Main_OnCommand(40297, 0) -- unSelect all Tracks
        r.SetTrackSelected(track, true)
            local razorLeft, razorRight = tonumber(razorLeft), tonumber(razorRight)
            if razorLeft  < left  then left  = razorLeft end
            if razorRight > right then right = razorRight end
        end
    end
end
if left <= right then
    r.GetSet_LoopTimeRange2(0, true, false, left, right, false)
end


r.Main_OnCommand(42406, 0) -- Clear RE Areas
r.Main_OnCommand(40718, 0) -- Select Item 
--r.Main_OnCommand(40061, 0) -- Split at Time Selection
--r.Main_OnCommand(40635, 0) -- Remove Time Selection
end

---------------------------------------End of RE_Splits----------------------------------------


function mix()

function select() -- local (i, j, item, take, track)

  UnselectAllTracks()

  selected_items_count = r.CountSelectedMediaItems(0)

  for i = 0, selected_items_count - 1  do
    item = r.GetSelectedMediaItem(0, i) -- Get selected item i
    track = r.GetMediaItem_Track(item)
    r.SetTrackSelected(track, true)
   active_take = r.GetActiveTake(item)
    item_name = r.GetMediaItemInfo_Value(item, "D_LENGTH") 
     _, nameTake = r.GetSetMediaItemTakeInfo_String(active_take,"P_NAME",0,0)
   sel_tracks2 = r.CountSelectedTracks()
 r.Main_OnCommand(r.NamedCommandLookup('_SWS_SAVESEL'), 0) 
    
  end
end

function UnselectAllTracks()
  first_track = r.GetTrack(0, 0)
  r.SetOnlyTrackSelected(first_track)
  r.SetTrackSelected(first_track, false)
end

select() -- Execute your main function

r.Main_OnCommand(41559, 0) --solo
r.Main_OnCommand(41174, 0) --Item navigation: Move cursor to end of items
r.Main_OnCommand(41040, 0)  --Go to start of next measure
r.Main_OnCommand(40296, 0)  ---Track: Select all tracks
   
function last_tr_in_folder (folder_tr)
  last = nil
  local dep = r.GetTrackDepth(folder_tr)
  local num = r.GetMediaTrackInfo_Value(folder_tr, 'IP_TRACKNUMBER')
  local tracks = r.CountTracks()
  for i = num+1, tracks do
    if r.GetTrackDepth(r.GetTrack(0,i-1)) <= dep then last = r.GetTrack(0,i-2) break end
  end
  if last == nil then last = r.GetTrack(0, tracks-1) end
  return last
end

sel_tracks = r.CountSelectedTracks()
if sel_tracks == 0 then return end

first_sel = r.GetSelectedTrack(0,0)
tr_num = r.GetMediaTrackInfo_Value(first_sel, 'IP_TRACKNUMBER')

last_sel = r.GetSelectedTrack(0,sel_tracks-1)
last_sel_dep = r.GetMediaTrackInfo_Value(last_sel, 'I_FOLDERDEPTH')
if last_sel_dep == 1 then last_tr = last_tr_in_folder(last_sel) else last_tr = last_sel end


r.InsertTrackAtIndex(tr_num-1, 1)
r.TrackList_AdjustWindows(0)
tr = r.GetTrack(0, tr_num-1)

r.SetMediaTrackInfo_Value(tr, 'I_FOLDERDEPTH', 1)
r.SetMediaTrackInfo_Value(last_tr, 'I_FOLDERDEPTH', last_sel_dep-1)
r.SetOnlyTrackSelected(tr)

r.Main_OnCommand(40914,0) -- Track: Set first selected track as last touched track
r.Main_OnCommand(r.NamedCommandLookup('_SWS_AWRENDERSTEREOSMART'), 0) ---SWS/AW: Render tracks to stereo stem tracks, obeying time selection
r.Main_OnCommand(r.NamedCommandLookup('_XENAKIOS_SELNEXTTRACK'), 0) ---Xenakios/SWS: Select next tracks
r.Main_OnCommand(r.NamedCommandLookup('_S&M_FOLDEROFF'), 0) ----SWS/S&M: Set selected tracks folder states to normal
r.Main_OnCommand(40005, 0) --Track: Remove tracks
r.Main_OnCommand(40635, 0) ---Time selection: Remove time selection
r.Main_OnCommand(41560, 0)   ---Item properties: Unsolo

    tr = r.GetTrack(0,r.CountTracks(0)-1)
    if tr then r.SetOnlyTrackSelected( tr ) end
    
r.Main_OnCommand(r.NamedCommandLookup('_S&M_FOLDEROFF'), 0)  ----SWS/S&M: Set selected tracks folder states to normal   
r.Main_OnCommand(40296, 0) --Select All 
r.Main_OnCommand(r.NamedCommandLookup('_XENAKIOS_SELFIRSTOFSELTRAX'), 0)   ---Xenakios/SWS: Select first of selected tracks
r.Main_OnCommand(40337, 0) --Track: Cut tracks
r.Main_OnCommand(r.NamedCommandLookup('_SWS_RESTORESEL'), 0)   -----restore tracks selection
r.Main_OnCommand(r.NamedCommandLookup('_XENAKIOS_SELLASTOFSELTRAX'), 0) ---Select last track
r.Main_OnCommand(40058, 0) ---Paste track    
--r.Main_OnCommand( r.NamedCommandLookup( "_RS056b25003bfa60cfe286cba2c702ae57ba5845a3"),  0 ) -- set random color

function rename()
tracks_count = r.CountSelectedTracks(0)
for i = 0, tracks_count - 1 do
    track = r.GetSelectedTrack(0, i)

r.Main_OnCommand(40421, 0)   --- Select New Item 

  selected_items_count = r.CountSelectedMediaItems(0)
  for i = 0, selected_items_count - 1  do
    item = r.GetSelectedMediaItem(0, i) -- Get selected item i
    active_take = r.GetActiveTake(item)
    r.GetSetMediaItemTakeInfo_String(active_take,"P_NAME",nameTake,1) -- set item name
end

if track then    
        nameTake = nameTake:sub(0,5) -- limit name to 5 symbols
        track_name_retval, track_name = r.GetSetMediaTrackInfo_String(track, "P_NAME", ( nameTake .." Mixdown ".. sel_tracks2 .. " " ..  "track(s)"), true) -- set track name
end
end

end

r.UpdateArrange ()

rename()

end
 
r.Main_OnCommand(r.NamedCommandLookup('_BR_SAVE_CURSOR_POS_SLOT_5'), 0)
r.Main_OnCommand(r.NamedCommandLookup('_SWS_SAVELOOP2'), 0)   ----- save selection
startOut, endOut = r.GetSet_LoopTimeRange2( 0, 0, 0, 0, 0, 0 ) --  Берём переменную "Time selection"

if startOut == endOut then
r.Main_OnCommand(r.NamedCommandLookup('_SWS_SAFETIMESEL'), 0)
end

selected_items_count = r.CountSelectedMediaItems(0)

if selected_items_count > 0 then 
mix()
end

r.Main_OnCommand(r.NamedCommandLookup('_SWS_RESTLOOP2'), 0)   -----restore selection
r.Main_OnCommand(r.NamedCommandLookup('_BR_RESTORE_CURSOR_POS_SLOT_5'), 0) 

r.GetSet_ArrangeView2(0,1,0,0,st_tm,en_tm);

r.PreventUIRefresh(-1)
r.Undo_EndBlock('Mixdown', 0)     
